package top.dreamcenter.noise.util;

public class Ball {
    public double x;
    public double y;
    public double z;
    public int cpt;
    public int grid;

    public Ball(double x, double y, double z, int cpt, int grid) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.cpt = cpt;
        this.grid = grid;
    }

    /**
     * 转为虚拟坐标
     */
    public void toV() {
        x = (x - cpt) / grid;
        y = (cpt - y) / grid;
    }

    public Dot getV() {
        Dot tmp = new Dot(x, y , cpt, grid);
        tmp.toV();
        return tmp;
    }

    /**
     * 转为实际坐标
     */
    public void toR () {

        x = x * grid + cpt;
        y = cpt - y * grid;
    }

    public Dot getR() {
        Dot tmp = new Dot(x, y , cpt, grid);
        tmp.toR();
        return tmp;
    }

    public BallInt toInt(){
        return new BallInt((int) x, (int) y, (int) z);
    }

    public static class BallInt{
        public int x;
        public int y;
        public int z;

        public BallInt(int x, int y, int z) {
            this.x = x;
            this.y = y;
            this.z = z;
        }
    }

    @Override
    public String toString() {
        return "Ball{" +
                "x=" + x +
                ", y=" + y +
                ", z=" + z +
                '}';
    }
}
